#define NACHBARNAEHE 7 // Bei welcher Distanz wird ein Fremder zum Nachbar
#define NACHBARKOLLISION 4 // Bei welcher Distanz tritt eine Kollision ein
#define REGEL1 175 // Gewichtung der Regel 1 (grosser wert = weniger bindung zum nachbar)
#define REGEL2 50 // Gewichtung der Regel 2 (kleiner wert = weichere kollision)
#define REGEL3 70 // Gewichtung der Regel 3 (grosser wert = langsame anpassung der geschwindigkeit)
#define OUTSIDER false // true gdw wir selbst nicht zum Zentrum gehoeren sollen
#define FISCHSPEED 400 // weniger = schneller

class Fisch
{
	protected:	float fischposx;
	protected:	float fischposy;
	protected:	float fischposz;
	protected:	float fischvektorx;
	protected:	float fischvektory;
	protected:	float fischvektorz;
	protected:	float fischspeed;
	protected:	float triggerspeed;
	protected:	float evil;
	protected:	bool lebendig;
	protected:	bool bewegtsich;
	protected:	bool slowDead;
	protected:	float slowmo;
	
	// Nachbaroptionen
	protected:	int nachbarcount;
	protected:	float nachbarzentrumx;
	protected:	float nachbarzentrumy;
	protected:	float nachbarzentrumz;
	protected:	float nachbarvektorx;
	protected:	float nachbarvektory;
	protected:	float nachbarvektorz;
	protected:	float nachbarspeed;

	// Ausrichtung vom Fisch
	protected:	int fischrotate; //Winkel
	protected:	int fischrotatex;
	protected:	int fischrotatey;
	protected:	int fischrotatez;

	// Leuchtfaehigkeit
	protected:	float ambience;

	// Text
	protected:	char *name;

	// Konstruktoren und Destruktoren
	public:		Fisch(char *n, int x, int y, int z);
	public:		~Fisch(void);

	// Zeichenmethoden
	public:		void display(void);
	protected:	void drawFisch(void);
	protected:	void drawFlosse(void);
	protected:	void drawRumpf(void);
	protected:	void drawSchwanz(void);
	protected:	void drawText(void);
	
	// Andere Methoden
	public:		void calculate(void);
	public:		void powerUp(void);
	public:		void powerDown(void);
	public:		void setEvil(bool e);
	
	public:		float entfernung(float x, float y, float z);
	public:		void checkNachbar(Fisch *nachbar);
	public:		void checkRaubfisch(Fisch *hai);
	public:		void resetNachbar(void);
	public:		void addNachbar(float entfernung, float speed, float px, float py, float pz);
	public:		void getPos(float* x, float* y, float* z);
	public:		void addDest(float px, float py, float pz, float speed);
	public:		void bewegungStop(void);
	public:		void moveUp(void);
	public:		void die();
	private:	void normalenVektor(float *res, float x1, float y1, float z1, float x2, float y2, float z2, float x3, float y3, float z3);
};
